﻿using System.Collections.Generic;
using System.IO;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// 리스트 텍스트 작성자
    /// </summary>
    public class ListTextWriter : TextWriter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 텍스트 작성자 리스트
        /// </summary>
        private List<TextWriter> textWriterList = new List<TextWriter>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 인코딩 - Encoding

        /// <summary>
        /// 인코딩
        /// </summary>
        public override Encoding Encoding
        {
            get
            {
                return Encoding.Unicode;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 추가하기 - Add(writer)

        /// <summary>
        /// 추가하기
        /// </summary>
        /// <param name="writer">작성자</param>
        public void Add(TextWriter writer)
        {
            this.textWriterList.Add(writer);
        }

        #endregion
        #region 쓰기 - Write(value)

        /// <summary>
        /// 쓰기
        /// </summary>
        /// <param name="value">값</param>
        public override void Write(char value)
        {
            foreach(TextWriter writer in this.textWriterList)
            {
                writer.Write(value);
            }
        }

        #endregion
        #region 쓰기 - Write(value)

        /// <summary>
        /// 쓰기
        /// </summary>
        /// <param name="value">값</param>
        public override void Write(string value)
        {
            foreach(TextWriter writer in this.textWriterList)
            {
                writer.Write(value);
            }
        }

        #endregion
        #region 버퍼 비우기 - Flush()

        /// <summary>
        /// 버퍼 비우기
        /// </summary>
        public override void Flush()
        {
            foreach(TextWriter writer in this.textWriterList)
            {
                writer.Flush();
            }
        }

        #endregion
        #region 닫기 - Close()

        /// <summary>
        /// 닫기
        /// </summary>
        public override void Close()
        {
            foreach(TextWriter writer in this.textWriterList)
            {
                writer.Close();
            }
        }

        #endregion
    }
}